#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec-vm
Version:	4.1.24
Release:	1%{dist}
Summary:	The Qubes qrexec files (qube side)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:	pam-devel
BuildRequires:	pandoc
BuildRequires:	qubes-libvchan-devel
BuildRequires:	qubes-core-qrexec-devel
BuildRequires:	lsb-core-noarch
BuildRequires:	systemd-devel

Requires:   python%{python3_pkgversion}
Requires:   qubes-core-qrexec = %{version}-%{release}

Provides:   qubes-core-agent-qrexec = 4.1.0-1
Obsoletes:  qubes-core-agent-qrexec < 4.1.0-1

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on a qube.

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-vm
#make -C doc PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} man

%install
make install-vm \
    DESTDIR=$RPM_BUILD_ROOT \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    SYSCONFDIR=%{_sysconfdir}

#make -C doc DESTDIR=$RPM_BUILD_ROOT \
#    PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} \
#    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%post
%systemd_post qubes-qrexec-agent.service

%preun
%systemd_preun qubes-qrexec-agent.service

%posttrans
# when upgrading from R4.0, %%postun of qubes-core-agent-qrexec will revert
# %%post of this package. Redo the action in %%posttrans
%systemd_post qubes-qrexec-agent.service
# and then start it back
if systemctl is-enabled qubes-qrexec-agent.service >/dev/null 2>&1; then
    systemctl start qubes-qrexec-agent.service
fi

%files
%defattr(-,root,root,-)
%config(noreplace) /etc/pam.d/qrexec
%dir /etc/qubes/rpc-config
/etc/qubes/rpc-config/README

%{_bindir}/qrexec-client-vm
%{_bindir}/qrexec-fork-server

%{_mandir}/man1/qrexec-client-vm.1*

/usr/lib/qubes/qrexec-agent
/usr/lib/qubes/qrexec-client-vm
/usr/lib/qubes/qrexec_client_vm
/lib/systemd/system/qubes-qrexec-agent.service

%changelog
* Mon Nov 20 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec.git

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bd27017
- version 4.1.24

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - eac41c6
- Adjust pylint config

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 56591ba
- qrexec-policy-graph: make output order deterministic

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 27077c2
- Fix log format

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7e75011
- qrexec-policy-graph: add basic tests

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 06a401b
- qrexec-policy-graph: print wildcard rules when specific argument requested

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 863cef6
- qrexec-policy-graph: validate and normalize source/target arguments

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 738ee41
- rpm: drop unused BR: python3-dbus

* Mon Nov 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3b8d619
- rpm: use https URL

* Mon Nov 20 2023 Ben Grande <ben.grande.b@gmail.com> - 74b0b4f
- Add missing dependency inotify

* Mon Nov 20 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 2db726e
- Use _exit(), not exit(), in child process after fork

* Mon Nov 20 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6606ca3
- Add a missing printf attribute

* Mon Nov 20 2023 Frédéric Pierret (fepitre) <frederic@invisiblethingslab.com> - e77c86a
- Support for Fedora 39

* Mon Sep 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3b468bf
- version 4.1.23

* Mon Sep 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 888a6e2
- Fix issues in qrexec-policy-agent found by pylint

* Mon Sep 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3986296
- cleanup pylintrc

* Sat Sep 16 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - d00820f
- Do not exit successfully if local process failed

* Tue May 23 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99eaa5c
- version 4.1.22

* Mon May 22 2023 Ben Grande <ben.grande.b@gmail.com> - ba12e34
- Fix missing include in RPC names in admin_client

* Mon May 22 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f0b1904
- Revert "Fix some mypy errors"

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9439779
- Use pytest_asyncio.fixture() for async test fixtures

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 691ae45
- Do not use 'annotation' future extension (R4.1)

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3e61902
- avoid option injection in 'make clean'

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f503643
- Clean up gcov cruft in 'make clean'

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a0535aa
- Fix make install when already installed

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c97b0d7
- Fix some mypy errors

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c6dad2f
- Forcibly rebuild C code for socket tests

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 57ce55f
- Avoid option injection for usernames starting with "-"

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ff36122
- Add missing static

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 7a3aa3f
- Add a missing #include

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - aaf1454
- More consistency checks in buffer code

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 297e098
- Correctly detect SOCK_CLOEXEC

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 558ade2
- Slightly better validation of data from dom0

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c5ab6cb
- Fix reserved identifier violations

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b6a5c65
- Avoid K&R function declarations

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5f580e0
- Ensure all data is sent to policy daemon

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 577a207
- Ignore stopped or continued children

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9efe28b
- Fix signal handling bugs

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 61baaa6
- Check return value of snprintf()

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5f57019
- Check the return value of strdup()

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c066679
- Make pylint happy

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6443f45
- Do not call asyncio.get_event_loop() before creating one

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7447e2c
- Wrap coroutine in a task before passing to asyncio.wait

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e63e87f
- Remove the connect_existing variable

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 30e4629
- qrexec-client-vm: add --help

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ef3b45d
- More error checking

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 490130c
- Add some error checking

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 90667fc
- Zero-initialize some stack variables

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 77d5c13
- version 4.1.21

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7d9fddf
- daemon: fix off-by-one in MSG_TRIGGER_SERVICE3 validation

